/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   ft_radix.c                                         :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: cchauvet <cchauvet@student.42angouleme.fr  +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2022/11/15 18:16:31 by cchauvet          #+#    #+#             */
/*   Updated: 2022/12/07 14:18:44 by cchauvet         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "pushswap.h"

void	ft_radix_sort(unsigned int *tab_a, unsigned int *tab_b)
{
	unsigned int	i;
	unsigned int	y;
	unsigned int	bit_shift;
	int				j;

	bit_shift = ft_bitlen(ft_get_max(tab_a)) + 1;
	i = 0;
	while (!ft_is_sorted(tab_a) && i < bit_shift)
	{
		y = ft_tablen(tab_a);
		while (0 < y && !(ft_is_sorted(tab_a) && !ft_tablen(tab_b)))
		{
			if (((tab_a[0] >> i) & 1) == 0)
				ft_pb(tab_a, tab_b);
			else
				ft_ra(tab_a);
			y--;
			j = 0;
			printf("tab_a:\n");
			while (tab_a[j] != STOP_VALUE)
				printf("%d\n", tab_a[j++]);
			j = 0;
			printf("tab_b:\n");
			while (tab_b[j] != STOP_VALUE)
				printf("%d\n", tab_b[j++]);
		}
		while (tab_b[0] != STOP_VALUE)
			ft_pa(tab_a, tab_b);
		i++;
		j = 0;
		printf("\n\nROUND[%d]\ntab_a:\n", i);
		while (tab_a[j] != STOP_VALUE)
			printf("%d\n", tab_a[j++]);
	}
}
